<?php
##### rrmodcompare_form.php, installed by ###Mod Manager Compare, by Robin Richmond
/* The Mod Comparison Report kickoff form, for TNGv13
This program invokes rrmodcompare_report.php to print the report.
This form lets the user
1. Specify the (optional) second site,
2. Indicate whether to search the TNG Wiki,
3. Specify a mod author to search for,
4. Whether to restrict the report to the mods written by the author,
5. Possible status values for the mods in the two environments or wiki.
6. Sort order
7. Caching settings that affect the speed of the report.
Defaults for some options are specified in the Mod Manager Options, as are additional
display options that aren't included in the kickoff form.
*/
#Set the flag that lets this program read the Mod Manager Compare language strings.
$mod_manager_compare_cust_text = 'form';
$tngModNames['Mod Manager Compare']['rrmodcompare_form.php'] = '7';
####################################################################

# Define values used by function set_horizontal_tabs
define( 'YES',1 );
define( 'NO', 0 );
include("begin.php");
include 'adminlib.php';
$textpart = "mods";
include("$mylanguage/admintext.php");

########################################################
#Read custom language strings from a mods subfolder rather than from regular cust_text.php files.
$modfolder = $admtext['mmmodfolder'];
if (file_exists("$modspath/$modfolder/{$mylanguage}_cust_text.php"))
	include("$modspath/$modfolder/{$mylanguage}_cust_text.php");
else include("$modspath/$modfolder/languages/English_cust_text.php");

# Don't require admin login
$admin_login = 0;
include 'checklogin.php';
include 'version.php';
include 'classes/version.php';
$helplang = findhelp("rrmodcompare_help.php");

################# Define Form Field Initial Values ############################
## Look for a cookie (any cookie whose value must be truthy)
## But if the reset button was clicked, ignore the cookies.
if (!isset($_GET['reset']) && !empty($_COOKIE['tng_modcompare']['rt'])) {
	#Revisiting this page; load field values from cookies
	#$power (basic/advanced) is the only cookie that is not a form field value.
	#(Each line of field values in this statement covers a section of the kickoff form)
	foreach (array('power', 'rt', 'needupdate', /*The first two sections*/
		'cachemethod', 'life', 'unit', 'sinclude', 'sexclude', 'private',
		'wiki', 'site2url', 'orphans', 'summary', 'author', 'ayesno',
		'aformat', 'statushilite', 'wrap', 'hideversion',
		'mismatch', 'showsuper', 'showcache', 'sb','aright', 'cachemethodused') AS $variable) {
		if (empty($_COOKIE['tng_modcompare'][$variable]))
			$$variable = '';
		else {
			$$variable = $_COOKIE['tng_modcompare'][$variable];
			if ($$variable == '(empty)') $$variable = '';
		}
	}

	#Override these field values with querystring parameters
	if (isset($_GET['life'])) $life = $_GET['life'];
	if (isset($_GET['unit'])) $unit = $_GET['unit'];
	if (isset($_GET['sinclude'])) $sinclude = $_GET['sinclude'];
	#(For now, don't) Ignore the saved cachemethod and always use 3 (fastest) after a report has been run
	#$cachemethod = 3;
} else { ############### Reset and First Page Load ##########
	#### Land here the first time this page is loaded in a browser session,
	#### or the the kickoff form's 'Reset to Defaults' button is clicked.
	#Initialize the kickoff form field from MM options
	#Some values don't have MM Options, and defaults are applied to some options that have empty values.
	$power = 'basic'; #The "additional options" section will be open, but not "advanced"
	$rt = $options['comparert'];
	$wiki = 1;
	$needupdate = isset($options['compareneedupdate']) ? $options['compareneedupdate'] : '';
	#Search Options
	$cachemethod = 2;
	$life = 5;
	$unit = 'days';
	$sinclude = $options['comparesinclude'];
	$sexclude = $options['comparesexclude'];
	$private = isset($options['compareprivate']) ? $options['compareprivate'] : '';

	#Advanced options
	#There are no defaults for searching the status values
	$site2url = $options['comparesite2url'];
	$author = $options['compareauthor'];
	$ayesno = '';  #There is no Mod Option for include or exclude author, so accept all authors.
	$orphans = '';

	#Display options
	$sb = $options['comparesb'];
	$aformat = $options['compareaformat'];
	if (!$aformat) $aformat = 'initial';
	$statushilite = $options['comparestatushilite'];
	$summary = '';
	$hideversion = $options['comparehideversion'];
	$mismatch = $options['comparemismatch'];
	$showsuper = isset($options['compareshowsuper']) ?  $options['compareshowsuper'] : '';
	$showcache = isset($options['compareshowcache']) ?  $options['compareshowcache'] : '';
	$aright = isset($options['comparearight']) ?  $options['comparearight'] : '';

} #end if initialize from MM Options or cookies

# Some defaults and conditions that imply other conditions
if (!$cachemethod) $cachemethod = 2;
if ($life=='') $life='5';
if (!$unit) $unit='weeks';
if (!$sb) $sb = 'modname';
if (!$rt) $rt = '1'; #basic report
if ($rt < 2) $wiki = 1; #Simple report implies Wiki
### End of option initialization

########################################################################
#Define an array of possible status values for the 4 columns of status values.
#There are only 3 elements in this array because the 'site1 vs wiki' and 'site2 vs wiki' columns contain
#the same list of values.
$statusValues = array('site-wiki' =>
					array('<wiki','=wiki', '>wiki', 'mmnolink', 'mmmissing', 'mmbadlink', '??'),
			'site2-site1' => array( '<site1', '=site1', '>site1', 'mmna', '??'));
if ($private) $statusValues['site-wiki'][] = 'mmprivate';

################ End of cookie and option setup ################

######### HTML STREAM STARTS HERE #############
$flags['tabs'] = $tngconfig['tabs'];
# Don't use Mod Manager styles $flags['modmgr'] = true;
tng_adminheader( $admtext['modmgr'], $flags );
?>

<script type='text/javascript' src='js/admin.js'></script>
<script type='text/javascript'>
var showstatus = '<?php echo $admtext['mmshowstatusvalues']; ?>';
var hidestatus = '<?php echo $admtext['mmhidestatusvalues']; ?>';
var unit= Array();
unit['minutes'] = "<?php echo $admtext['mmminutes']; ?>";
unit['hours'] = "<?php echo $admtext['mmhours']; ?>";
unit['days'] = "<?php echo $admtext['mmdays']; ?>";
unit['weeks'] = "<?php echo $admtext['mmweeks']; ?>";

/////////////////////////////////////////////////////
///////////////Document.ready function /////////////
$(function() {
	//Override the MM default in which the content table scrolls, but not the page
	//////////////////////////////////////////////////
	//Insert this program's standalone style sheet in the DOM before genstyle.css so
	//modifications to this stylesheet can be made in genstyle.css.
	$("link[href^='css/genstyle.css']").before("<link rel='stylesheet' type='text/css' href='css/rrmodcompare.css'/>");

	//////////////////////////////////////////////////
	// Initialize the display of elements that are dependent on form field values.
	setSite2ElementsVisibility(0);
	setWikiElementsVisibility(0);
	setReportType(0);
	setAuthorElementsVisibility();
	formatSubheading('cache')
	formatSubheading('basic');
	formatSubheading('advanced');
	formatSubheading('display');

	///// Onclick and Onchange functions /////
	//Report type checkboxes
	$("input[name='rt']").click(function() {
		setReportType(1);
	});
	//Wiki checkbox
	$("#wiki").click(function() {
		setWikiElementsVisibility(1);
		formatSubheading('cache')
		formatSubheading('advanced');
		formatSubheading('display');
	});
	//Search for mods that have a newwer version ("needupdate")
	//If the Search Wiki checkbox is off and we're turning NeedUpdate checkbox on,
	//then we have to set the Search Wiki checkbox, and do everying that entails.
	$("#needupdate").click(function() {
		if (!$('#wiki').is(':checked') && $(this).is(':checked')) {
			//Set the wiki flag. Note that unchecking this box does not uncheck the wiki flag
			$('#wiki').prop('checked',true);
			setWikiElementsVisibility(1);
		}
		//Set/unset the site1vwiki status field for the value "<wiki" to match
		//the "needupate" checkbox
		$(".statuscheckbox[value='<wiki'][name^='site1vwiki']" ).prop('checked',$('#needupdate').is(':checked'));
	}); //end click #needupate
	//Cache method 2 radio button
	$("#method2").click(function() {
		if ($("#life").val() == '') $("#life").val('0');
	});
	//Unit radio buttons & cache lifetime input box. Set method 2
	$("input[name='unit']").click(function() {
		$('#method2').prop('checked',true);
	});
	$("#life").change(function() {
		$('#method2').prop('checked',true);
	});
	//Second Site field ("site2rl")
	$("#site2url").change(function() {
		setAuthorElementsVisibility(1);
	});
	//Author field - this function must be called in other situations, too.
	$("#author").change(setAuthorElementsVisibility);
	//Status checkboxes 
	//The site1vwiki checkbox is tied to the "Need update" checkbox
	$(".statuscheckbox").click(function() {
		if ($(this).val()=="<wiki" && $(this).attr('name')=='site1vwikifield[]')
			$("#needupdate").prop('checked',$(this).is(':checked'));
	});
}); //End of document.ready function

//////////////////////////////////////////////////
//Format one section subheading to summarize the values in that section
function formatSubheading(section) {
	if (section == 'cache') {
		if ($("#method1").is(':checked'))
			$("#appendcache").text("<?php echo $admtext['mmignorecache']; ?>");
		else if ($("#method2").is(':checked'))
			$("#appendcache").text(setCacheMethod2Description());
		else if ($("#method3").is(':checked'))
			$("#appendcache").text("<?php echo $admtext['mmalwayscache']; ?>");
	} else if (section == 'basic') {
		switchStyling($('#sinclude').val() || $('#sexclude').val(), 'strings');
		switchStyling($('#private').is(':checked'), 'private')
	} else if (section == 'display') {
		$('#appendsortby').text($("input[name='sb']:checked").val());
		var aformat=$("input[name='aformat']:checked").val()
		if (aformat=='none') {
			switchStyling(0,'aformat1');
			$('#appendaformat2').text('');
		} else {
			switchStyling(1,'aformat1');
			$('#appendaformat2').text(':'+$("input[name='aformat']:checked").val());
		}
		switchStyling($('#statushilite').is(':checked'), 'colorcode');
		switchStyling($('#summary').is(':checked') && !$('#summary').prop('disabled'), 'summary');
	} else if (section == 'advanced') {	
		switchStyling($('#site2url').val() && !$('#site2url').prop('disabled'), 'site2')
		switchStyling($('#author').val(), 'author')
		switchStyling($('#author').val() && !$('#ayesnoall').is(':checked'), 'ayesno')
		//Scan the status values. The first that is checked tells us that
		//there is a constraint. We have to look at all of them before we
		//can say that there is no constraint.
		var noStatusValues = true;
		$(".statuscheckbox").each( function() {
			if ($(this).is(':checked')) {
				$('#appendstatus').addClass('hasValue');
				$('#appendstatus').removeClass('noValue');
				noStatusValues = false;
				return;
			}
		});
		if (noStatusValues) {
			$('#appendstatus').removeClass('hasValue');
			$('#appendstatus').addClass('noValue');
		}
	} //end cascading if for each section of the form
} //end function formatSubheading

///////////////////////////////////////////////////////////
// Change the syling of labels in form section subheadings
function switchStyling(onoff, elementID) {
	if (onoff) {
		$('#append'+elementID).addClass('hasValue');
		$('#append'+elementID).removeClass('noValue');
	} else {
		$('#append'+elementID).removeClass('hasValue');
		$('#append'+elementID).addClass('noValue');
	}
} //end function switchStyling

///////////////////////////////////////////////////////////////
//Doesn't really validate; just disables some fields in order to reduce
//the number of querystring parameters in the URL generated by the form
function validateSubmit() {
	if (!$("#site2url").val())
		$("#site2url").prop('disabled',true);
	if (!$("#sinclude").val()) $("#sinclude").prop('disabled',true);
	if (!$("#sexclude").val()) $("#sexclude").prop('disabled',true);
	if (!$("#author").val())
		$("#author,input[name='ayesno']").prop('disabled',true);
	if ($("#ayesnoall").is(':checked'))
		$("input[name='ayesno']").prop('disabled',true);
	if (!$("#method2").is(':checked'))
		$("life,input[name='unit']").prop('disabled',true);
	if ($("#method3").is(":checked"))
		$("input[name='cachemethod']").prop('disabled',true);
	if (!$("#life").val())
		$("#life").prop('disabled',true);
	if ($("#unithours").is(':checked'))
		$("input[name='unit']").prop('disabled',true);
	if ($("#authorinitial").is(":checked"))
		$("input[name='aformat']").prop('disabled',true);
	return true;
} //end function validateSubmit

//////////////////////////////////////////////////////////////////////////
//function to change the state of a form section
//Copied from toggleSection in admin.js
// section is used as an element ID suffix for the trangular arrow, the
//        section's wrapping elementg, and the subheading (prefix='append')
// onoff is 'on' or "off"
function toggleFormSection(section, onoff) {
	if (onoff == 'on') {
		//Opening the section
		if (section=='basic') {
			$('#power').val('basic');
			$('.notbasic').hide();
		} else if (section=='advanced') {
			$('#power').val('advanced');
			$('#divbasic').show();
			$('#imgbasic').attr('src','img/tng_collapse.gif');
			$('#appendbasic').hide();
			setSite2ElementsVisibility(1);
		} else if (section=='display') {
			//We only need the second submit button when the display options are open
			$('#submit2').show();
		}
		$('#img'+section).attr('src','img/tng_collapse.gif');
		$('#div'+section).show();
		$('#append'+section).hide();
	}
	else { // Closing the section
		if (section=='basic') {
			$('#divadvanced').hide();
			$('#imgadvanced').attr('src','img/tng_expand.gif');
			formatSubheading('advanced');
			$('#appendadvanced').show();
			$('#power').val('');
			$('.notbasic').show();
			setSite2ElementsVisibility(1);
		} else if (section=='advanced') {
			$('#power').val('basic');
			setSite2ElementsVisibility(1);
		} else if (section=='display') {
			$('#submit2').hide();
			formatSubheading('display');
		}
		formatSubheading(section);
		$('#img'+section).attr('src','img/tng_expand.gif');
		$('#div'+section).hide();
		$('#append'+section).show();
	}
	return false;
} //end function toggleFormSection

//////////////////////////////////////////////////////////////////////////
//Onchange function for the Site2 form field in the kickoff form. Sets the display
//status of other form fields that deal with site 2 and sets the visibility
//of the X and Def buttons.
//For instance, there's no point in displaying options to select Site2 vs Wiki
//status values if we're not looking at a second site.
function setSite2ElementsVisibility(checkReportType) {
	var url = $('#site2url').val();
	if (url && !$('#site2url').attr('disabled')) {
		//Show elements that are only dependent on site2, but for elements
		//that are also dependent on the wiki, we need to check the wiki status.
		$('.rrsite2display').show();
		if ($('#wiki').is(':checked'))
			$('.rrwikiandsite2').show();
		$('.rrwikiorsite2').show();
		$('.rrwikiNORsite2').hide();
		//Re-hide elements that reporttypes 1 or 2 cannot handle
		if (checkReportType) setReportType(0);
	} else { //site2 url has no value or is disabled
		//Hide elements that are dependent only on site2 as well as
		//elements that depend on the wiki & site2.
		$('.rrsite2display').hide();
		$('.rrwikiandsite2').hide();
		if (!$('#wiki').is(':checked')) {
			$('.rrwikiorsite2').hide();
			$('.rrwikiNORsite2').show();
		}
	}
	return false;
} //end function setSite2ElementsVisibility

/////////////////////////////////////////////////////
//Onclick function for the "Search Wiki" checkbox in the kickoff form
//Set the display status of other elements that deal with the Wiki.
//The checkbox is only visible in Advanced options
//For instance, there's no point in displaying options to select Site2 vs. Wiki
//status values if we're not looking at the wiki.
function setWikiElementsVisibility(checkReportType) {
	//When the search wiki field is set, we want to display wiki-related form fields
	if ($("#wiki").is(':checked')) {
		//Show elements that are only dependent on the wiki, but on some
		//elements we need to deal with site2 or the reporttypes.
		$('.rrwikiorsite2').show();
		if ($('#site2url').val())
			$('.rrwikiandsite2').show();
		$('.rrwikiNORsite2').hide();
		$('.rrwikidisplay').show();
		$('#needupdate').prop('disabled',false);
		$('#needupdatediv').removeClass('greyedOut');
		$('#summary').prop('disabled',false);
		$('#summarydiv').removeClass('greyedOut');
		//Re-hide elements that reporttypes 1 or 2 cannot handle
		if (checkReportType) setReportType(0);
	} else { //Hide or change elements that are dependent on the wiki
		$('.rrwikidisplay').hide();
		$('.rrwikiandsite2').hide();
		if (!$('#site2url').val()) {
			$('.rrwikiorsite2').hide();
			$('.rrwikiNORsite2').show();
		}
		$('#needupdate').prop('disabled',true);
		$('#needupdatediv').addClass('greyedOut');
		$('#summary').prop('disabled',true);
		$('#summarydiv').addClass('greyedOut');
		$('#reporttype2').prop('checked',true);
		setReportType(0);
		toggleFormSection('cache','off');
	}
	return false;
} //End function setWikiElementsVisibility

/////////////////////////////////////////////////////
//Onchange function for the "Author to search for" field in the kickoff form to toggle
//the display of other elements that deal with the Author.
//For instance, there's no point in displaying options to select mods written by a
//specific author, if no author is specified.
function setAuthorElementsVisibility() {
	var currentAuthor = $('#author').val();
	if (currentAuthor) {
		$(".ayesno").attr('disabled',false);
		$("#authormods").removeClass('greyedOut');
		$("#authormods").attr('disabled',false);
		//<span> element that displays the author name
		$('.authorname').text(currentAuthor);
	} else { //No author value
		$(".ayesno").attr('disabled',true);
		$("#wiki").prop('checked',true);
		$("#authormods").addClass('greyedOut');
		$("#authormods").attr('disabled',true);
		$('.authorname').text("<?php echo $admtext['mmcauthor']; ?>");
	}
	return false;
} //End function setAuthorElementsVisibility

////////////////////////////////////////////////
//Onclick function for the "Show status values/Hide" button.
//This function changes the text of the button and the display status of the status values.
//but doesn't do anything if the button's text indicated that it is inactive.
function toggleStatusCriteriaVisibility() {
	if ($('#statusbutton').html() == showstatus) {
		$('#statusbutton').html(hidestatus);
		$('#statuswrap').show();
	} else if ($('#statusbutton').html() == hidestatus) {
		$('#statusbutton').html(showstatus);
		$('#statuswrap').hide();
	}
	return false;
} //end function toggleStatusCriteriaVisibility

///////////////////////////////////////////////////////
// Set the display status of fields based on the report type
function setReportType(checkOtherConditions) {
	if ($("#reporttype2").is(':checked')) {
		$(".nottype1").attr('disabled',false);
		$("#site2div").removeClass('greyedOut');
		$(".site2field").attr('disabled',false);
	} else { //Reporttype 1 is checked
		$(".nottype1").attr('disabled',true);
		$("#wiki").prop('checked',true);
		$("#site2div").addClass('greyedOut');
		$(".site2field").attr('disabled',true);
	}
	if (checkOtherConditions) {
		setWikiElementsVisibility(0);
		setSite2ElementsVisibility(0);
	}
} // end function setReportType

////////////////////////////////////////////////////
//Generate a description of the "use cache if..." rule
function setCacheMethod2Description () {
	//Determine the unit value (week,day,hour)
	var units;
	$("input[name='unit']").each( function() {
		if ($(this).is(':checked')) units = $(this).val();
	});
	var msg = "<?php echo $admtext['mmusecacheless']; ?>".replace('XXX',$('#life').val()).replace('YYY',units);
	return msg;
} //End function setCacheMethod2Description

//////////////////////////////////////////////////////////
//Function to pop up a hint when a specific info button is clicked.
//The hint text and the title of the popup box are stored in hidden divs.
function showPopupHint(hintname, width, height) {
	var content = "<div class='rrlitboxhint'>" + $('#rr'+hintname+'hint').html();
	content += "<footer>" + $('#mmfootnote').html() + "</footer></div>";
	var title = $('#rr'+hintname+'title').html();
	new LITBox(content,{type:'alert', width:width, height:height, overlay:false, title:title});
	return false;
} //End function showPopupHint
</script>
<?php
#Load the Field Buttons Library (unless all fields are disabled), and initialize Field Button variables
if (file_exists('js/fieldbuttonsmod.js') && $tngconfig['rrfieldbuttonflags'] != '0,0,0,0' ) {
	if (!isset($rrButtonsAlreadyInstalled)) {
		echo "<script id='fieldbuttonsmod' type='text/javascript' src='js/fieldbuttonsmod.js'></script>\n";
		$rrButtonsAlreadyInstalled =1;
	}
?>
	<script type="text/javascript">
	rrButtonsFinalSetupFunctions.push(function() {
		//Pass the field button labels & flags to the Field Buttons library.
		rrButtonsSetLabels ("<?php echo $admtext['rrfb-buttonlabels']; ?>");
		rrButtonsSetFlags ("<?php echo $tngconfig['rrfieldbuttonflags']; ?>");
		//Values assigned to form fields by their 'D' (Default) field buttons
		rrButtonsValues['site2url']['D'] = '<?php echo $options['comparesite2url']; ?>';
		rrButtonsValues['author']['D'] = '<?php echo $options['compareauthor']; ?>';
		rrButtonsValues['sinclude']['D'] = '<?php echo $options['comparesinclude']; ?>';
		rrButtonsValues['sexclude']['D'] = '<?php echo $options['comparesexclude']; ?>';

		//Functions that need to be called by field button onClick events.
		rrButtonsOnClickFunctions['site2url'].push(function() { setSite2ElementsVisibility(1); });
		rrButtonsOnClickFunctions['author'].push(function() { setAuthorElementsVisibility(); });
	});
	</script>
<?php
} #end if the field buttons library is installed
else { #No field buttons library => we need a couple of dummy functions
	echo "<script>
		function rrButtonsSetVisibility(){};
		function rrButtonsSetVisibilityAll(){};
	</script>\n";
}
#### End of Field Buttons setup
#####################################################################
### End of JavaScript - Close the page <head> and start the page <body>

echo "</head>\n";
echo tng_adminlayout();

$modtabs = set_horizontal_tabs( $options['show_analyzer'], $options['show_developer'], $options['show_updates']);
# inner menu link to Mod Manager Comparison Report help
$innermenu = "<a href='$helplang/rrmodcompare_help.php' onclick=\"return openHelp('$helplang/rrmodcompare_help.php');\" class='lightlink'>{$admtext['mmcomparehelp']}</a>";
# link to the Mod Comparison wiki article.
$innermenu .= " &nbsp | &nbsp; <a href='https://tng.lythgoes.net/wiki/index.php/Mod_Manager_Compare_' onclick=\"return openHelp('https://tng.lythgoes.net/wiki/index.php/Mod_Manager_Compare');\" class='lightlink'>{$admtext['mmcomparewiki']}</a>";

$menu = "<div class=\"mmmenuwrap\">";
$menu .= doMenu($modtabs,"compare",$innermenu);
$menu .= "</div>";

if(!isset($message)) $message = "";
$headline = displayHeadline($admtext['modmgr'],"img/modmgr_icon.gif",$menu,$message);
echo "<div id=\"mmhead\" class=\"$headclass adminback\">
	$headline
</div><!--head-section-->\n";
?>
<table width='100%' border='0' cellpadding='6' class='lightback'>
	<tr class='databack'>
	<td class='tngshadow normal'>
<?php
	echo "<form action='rrmodcompare_report.php' id='modform' style='overflow:none;' class='normal rrformspacing'>\n";

		##Hidden field that indicates which level of options is displayed
		echo "<input type='hidden' name='power' id='power' value='$power'>\n";
		$site1server = $tngdomain;
		## Submit button && Reset to Defaults button
		echo "<div style='float:right;'>
			<input type='submit' name='b1' value=\"{$admtext['mmsubmit']}\" onclick='return validateSubmit();'> &nbsp;
			<input type='button' name='reset' value='{$admtext['mmresetdefaults']}'
				onclick=\"window.location.href = 'rrmodcompare_form?reset=1';\">\n";
		echo "</div>\n";

		echo '<div>' . str_replace('XXX', "<a href='admin_modoptions.php?open=compare'>{$admtext['mmoptions']}</a>", $admtext['mmfinddefaults']) . "</div>\n";

	################ Three Basic Options ######################
	echo "<div class='mmsectiontext'>{$admtext['mmcbasicoptions']}</div>
			<div class='optionssection'>\n";
		$checked1 = ($rt == '1') ? ' checked' : '';
		$checked2 = ($rt == '2') ? ' checked' : '';
		###Report type
		echo "<div><b>{$admtext['mmformatheading']}</b>: 
			<label class='nw'><input type='radio' name='rt' id='reporttype1'
				value='1'$checked1>{$admtext['mmcreportdesc1']} &nbsp</label>
			<label class='nw'><input type='radio' name='rt' id='reporttype2'
				value='2'$checked2>{$admtext['mmcreportdesc2']}</label>\n";

		##Display data from Wiki?
		$checked = ($wiki || $needupdate) ? ' checked' : '';
		echo "<div><b>{$admtext['mmcomparethis']}</b> ($site1server)<b>
			<label class='nw'>{$admtext['mmto']} {$admtext['mmtngwiki']}</b>
			<input type='checkbox' name='wiki' id='wiki' value='1'$checked>
			</div>\n";

		## Simple focus on version < wiki
		##Without advanced options, we are always comparing this site to the wiki.
		#Focus on mods that have a newer version on the Wiki.
		if ($wiki) {
			$disabled=''; $classname='';
		} else {
			$disabled=' disabled'; $classname=' greyedOut';
		}
		$checked = ($needupdate) ? ' checked' : '';
		echo "<div id='needupdatediv' class='$classname'>
				<label class='nw'><b>{$admtext['mmfocusonnewer']}:</b>
				<input type='checkbox' id='needupdate' name='needupdate' value='1'$checked$disabled></label>
			</div>\n";
		echo "</div>\n"; #end the "Basic Options" section


	### CACHE OPTIONS #### - always start closed
	#If "don't use the cache" was used, switch to "Use the cache if"
	if (isset($cachemethodused) && $cachemethodused == 1) $cachemethod = 2;
	else $cachemethodused = 1;

	#Compute the message to display in the "Cache Options" heading
	if ($wiki) {
		if ($cachemethod==1)
			$headingmsg = $admtext['mmignorecache'];
		elseif ($cachemethod==2)
			$headingmsg = str_replace('YYY', $unit, str_replace('XXX', $life, $admtext['mmusecacheless']));
		else $headingmsg = $admtext['mmalwayscache'];
	} else $headingmsg = $admtext['mmnowiki'];
	#If we switched cache methods, make the message bold
	if ($cachemethodused == 1)
		$headingmsg = "<b style='color:brown;'>{$admtext['mmcchanged']}:</b> $headingmsg";
	#The cache info icon that was defined earlier goes at the end of the cache method description
	$cacheheading = "{$admtext['mmccacheopt']}<span class='rrtextlink'
		onclick=\"return showPopupHint('speed',520,320);\"
		title=\"{$admtext['mmwikicachemethod']}\"><img src='img/info_2.png'></span>";

	echo generateSectionToggle('cache', false, "$('#divcache').css('display')!='none'",
		$cacheheading, $headingmsg);

	echo "<div id='divcache' class='optionsection mmdisplaynone'>\n";
		echo "<ol style='margin-top:0;margin-bottom:0;'>";
			$checked = $cachemethod==1 ? ' checked' : '';
			echo "<li><label><input type='radio' name='cachemethod'
					id='method1' value='1'", ($cachemethod==1 ? ' checked' : ''),
					">{$admtext['mmignorecache']}</label></li>\n";
			#Cache method 2 contains the expiration lifetime and units (minute, hour, etc.)
			$checked = $cachemethod==2 ? ' checked' : '';
			echo "<li><span class='nw'><label><input type='radio' name='cachemethod' id='method2'
				value='2'$checked>{$admtext['mmusecache']}</label> ";
					#The cache lifetime, which sets method 1 if it is zero, and sets method 2 otherwise
					echo "<label><input type='number' name='life' id='life' value='$life' style='width:4em;'>
						</label></span>\n"; #end the non breaking span for the radio button & lifetime
					echo "</span>\n";
					#Time units radio button set
					if (!$unit) $unit='days';
					echo "<span class='nw'>
					<label><input type='radio' name='unit' value='weeks'",
						($unit=='weeks' ? ' checked' : ''), ">{$admtext['mmweeks']}</label>
					<label><input type='radio' name='unit' id='days' value='days'",
						($unit=='days' ? ' checked' : ''), ">{$admtext['mmdays']}</label>
					<label><input type='radio' name='unit' value='hours' id='unithours",
						($unit=='hours' ? ' checked' : ''), ">{$admtext['mmhours']}</label>
					<label><input type='radio' name='unit'value='minutes'",
						($unit=='minutes' ? ' checked' : ''), ">{$admtext['mmminutes']}</label>
					</span>
					</li>\n";
			$checked = $cachemethod==3 ? ' checked' : '';
			echo "<li><label><input type='radio' name='cachemethod' id='method3'
				 value='3'$checked>{$admtext['mmalwayscache']}
				<span class='nw'>{$admtext['mmrepeatreport']}</span></label>
				</li>\n";
		echo "</ol>
		</div>\n";

	### BASIC SEARCH OPTIONS ####
	if ($power) { $hidden=''; $initialstate=1; }
	else { $hidden = ' mmdisplaynone'; $initialstate=0; }

	#Seed the subheading with two span elements for "search strings" and "private mods"/
	$headingmsg = "<span id='appendstrings'>{$admtext['mmcstrings']}</span>,
		<span id='appendprivate'>{$admtext['mmcpmods']}</span>";

	echo generateSectionToggle('basic', $initialstate, "$('#power').val()",
		$admtext['mmcotherptions'], $headingmsg);
	echo "<div id='divbasic' class='optionsection$hidden'>\n";

		###Include and exclude substrings.
		$searchcriteria = "<div>{$admtext['mmsearchinclude']}:
			<input type='text' name='sinclude' id='sinclude' class='rrsearchtext rrbtnx rrbtnr rrbtnd'
			size='20' value=\"$sinclude\"/>&nbsp;\n";

		###Show the Regular Expressions button only if we are in 'advanced' mod.
		$hidden = ($power=='advanced') ? '' : ' mmdisplaynone';
		$searchcriteria .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<a href='#' class='snlink rradvanced$hidden' style='padding:2px;'
				onclick=\"return showPopupHint('regex',520,170);\">
				{$admtext['mmcregex']}<img src='img/info_2.png'></a>\n";
		#Search string for EXclusion - with X,R and D field buttons
		$searchcriteria .= "<br/>{$admtext['mmsearchexclude']}:
			<input type='text' name='sexclude' id='sexclude' class='rrsearchtext rrbtnx rrbtnr rrbtnd' 
				size='20' value=\"$sexclude\"/>
			</div>\n"; #Close the div for the Include & Exclude fields

		###Include Private Mods?
		$checked = $private ? ' checked' : '';
		$searchcriteria .= "<div><label>{$admtext['mmprivateopt']}?
			<input type='checkbox' name='private' id='private' value='1'$checked/></label>
			</div>\n";
		echo $searchcriteria;
	echo "</div>\n"; #End the Basic search options

	#Place a submit button at the bottom of the basic options, but don't display
	#it unless the Display options are open and thus extend the length of the form.
	echo "<div id='submit2' class='mmdisplaynone' style='float:right;'>
		<input type='submit' name='b1' value=\"{$admtext['mmsubmit']}\" onclick='return validateSubmit()'>
		</div>\n";

	################### Advanced options #####################
	if ($power=='advanced') { $hidden=''; $initialstate=1; }
	else {$hidden=' mmdisplaynone'; $initialstate=0; }

	#Seed the subheading with four span elements for "second site, "author", "author constrint", and "status values";
	$headingmsg = "<span id='appendsite2'>{$admtext['mmcsite2']}</span>,
		<span id='appendauthor'>{$admtext['mmcauthor']}</span>, 
		<span id='appendayesno'>{$admtext['mmcaconstraint']}</span>, 
		<span id='appendstatus'>{$admtext['mmcstatusvalues']}</span>";

	echo generateSectionToggle('advanced', $initialstate, "$('#power').val()=='advanced'",
		$admtext['mmadvancedoptions'], $headingmsg);
	echo "<div id='divadvanced' class='optionsection$hidden'>\n";

		#Site2 field, with X, R, and D field buttons, and onchange functions
		#to toggle other site2 options,
		$fieldsize = ($site2url) ? strlen($site2url)+8 : 35;
		$placeholder = ''; #$admtext['mmsite2pr']; -- string def is missing; not sure what it is supposed to be
		echo "<div id='site2div' class='notlevel1'>
			<div class='nw'>{$admtext['mmccompareto']}
			<input type='text' name='site2url' id='site2url' class='rrbtnx rrbtnr rrbtnd site2field'
			size='$fieldsize' value='$site2url' placeholder='{$admtext['mmsite2ph']}'>
			</div>\n"; #end of site2URL

		##Show mods that are only on site 2
		$checked = $orphans ? ' checked' : '';
		echo "<div><label>{$admtext['mmcorphans']}
			<input type='checkbox' name='orphans' class='site2field' value=1'></label></div>\n";
		echo "</div>\n"; #the site 2 div

		$searchcriteria = '';
		##Author to search for
		$searchcriteria .= "<div>
		<label>{$admtext['mmcsearchauthor']}: <input type='text' name='author'
			id='author' class='rrbtnx rrbtnr rrbtnd' size='25' value=\"$author\">
			</label></div>\n";

		#Include, exclude, or highlight the Mod author. If there is no
		#author, this radio button set is garbled, so grey it out.xyz
		$hidden = $author ? '' : ' greyedout';
		$searchcriteria .= "<div id='authormods' class='searchoption$hidden''>
			<span class='nw'>{$admtext['mmshowmodsthat']}
			<label><input type='radio' name='ayesno' class='ayesno' value='y'".
				($ayesno=='y' ? ' checked' : '') ."/>{$admtext['mmare']}</label>
			<label><input type='radio' name='ayesno' class='ayesno' value='n'" .
				($ayesno=='n' ? ' checked' : '') . "/>{$admtext['mmnot']}</label>
			{$admtext['mmwrittenby']}</span>
			<span class='authorname'>$author</span>,
			{$admtext['mmcorjust']}
			<label class='nw'><input type='radio' name='ayesno' class='ayesno' value=''
				id='ayesnoall'" . ($ayesno=='' ? ' checked' : '') .
				">{$admtext['mmchilite']} \"<span class='authorname'>$author</span>\"</label>
			</div>\n";

		#Set up the checkboxes that allow the user to search for status values.
		$searchcriteria .= defineStatusSelectionColumns();

		echo "<section>$searchcriteria</section></div>\n";
	echo "</div>\n"; #End the advanced criteria

	####################### The Display Options ######################################
	#Seed the subheading with two options - highlight status, and mod summaries.
	$headingmsg = "<b>{$admtext['sortby']}</b>:<span id='appendsortby'></span>,
		<span id='appendaformat1'>{$admtext['mmcauthor']}</span><span id='appendaformat2'></span>,
		<span id='appendcolorcode'>{$admtext['mmccolorcode']}</span>,
		<span id='appendsummary'>{$admtext['mmcsummaries']}</span>";

	echo generateSectionToggle('display', 0, "$('#divdisplay').css('display')!='none'", $admtext['mmdisplayoptions'], $headingmsg);

	echo "<div id='divdisplay' class='optionsection mmdisplaynone'>\n";
		#####Basic display options - sortby
		echo "<div id='sortbydiv'><b>{$admtext['sortby']}:</b>\n";
			### Sortby radio buttons - generated by a loop through possible sort values.
			#Each of the radio buttons is wrapped by a <label> element to which classes are applied.
			foreach (array('modname|nw', 'filename|nw', 'author|nw',
					'date|nw rrwikidisplay nottype0') as $twopartvalue)
					showSortChoice($twopartvalue);
			echo "\n<span class='nw'>";
			foreach (array('site1vwiki|nw rrwikidisplay nottype0',
					'site2vsite1|nw rrsite2display nottype1',
					'site2vwiki|nw rrwikiandsite2 nottype1') as $twopartvalue)
					showSortChoice($twopartvalue);
			echo "</span></div>\n";

		### Author name format
		echo "<div><b>{$admtext['mmauthorformat']}</b>:
			<label class='nw'><input type='radio' name='aformat' value='first'" .
				($aformat=='first' ? 'checked' : '') . "/>{$admtext['mmauthorfirst']}</label>&nbsp;
				<label class='nw'><input type='radio' name='aformat' id='authorinitial' value='initial'" .
				($aformat=='initial' ? 'checked' : '') . "/>{$admtext['mmauthorinit']}</label>&nbsp;
				<label class='nw'><input type='radio' name='aformat' value='full'" .
				((!$aformat || $aformat=='full') ? 'checked' : '') . "/>{$admtext['mmauthorfull']}</label>
				<label class='nw'><input type='radio' name='aformat' value='none' id='noauthor'" .
				($aformat=='none' ? 'checked' : '') . "/>{$text['none']}</label>
			</div>\n";

		### Color-code Status Values
		$checked = $statushilite ? ' checked' : '';
		echo "<div><a href='#' onclick=\"return showPopupHint('hilite',420,170);\"
			title=\"{$admtext['mmhilitetitle']}\"><img src='img/info_2.png'></a>
			<label>{$admtext['mmstatushilite']}?
			<input type='checkbox' name='statushilite' id='statushilite' value='1'$checked/></label>
			</div>";

		### Show mod summaries
		$checked = $summary ? ' checked' : '';
		echo "<div id='summarydiv'><label>{$admtext['mmcmodsummaries']}?
			<input type='checkbox' name='summary' id='summary' value='1'$checked/></label>
			</div>";

		### Message: the following options are most useful for mod programmers
		echo "<table class='normal optionstable'>
			<tr><td colspan='2' class='rrhline'><b>{$admtext['mm4programmers']}</b></td></tr>";

			### Hide the version # portion of the mod filename if it matches the version #
			$checked = $hideversion ? ' checked' : '';
			echo "<tr><td><label for='hideversion'>{$admtext['hideversion']}</label></td>
					<td><input type='checkbox' name='hideversion' value='1'$checked>
					</td></tr>\n";

			### Highlight if filename doesn't match the mod name or version #
			$checked = $mismatch ? ' checked' : '';
			echo "<tr><td><label for='mismatch'>{$admtext['mmflagmismatches']}</label></td>
				<td><input type='checkbox' name='mismatch' value='1'$checked>
				</td></tr>\n";

			### Use superscript flags for author name source and Wiki articles under construction
			$checked = $showsuper ? ' checked' : '';
			echo "<tr><td><label for='showsuper'>{$admtext['mmshowsuper']}</label></td>
				<td><input type='checkbox' name='showsuper' value='1'$checked>
				</td></tr>\n";

			### Show cache age
			$checked = $showcache ? ' checked' : '';
			echo "<tr><td><label for='showcache'>{$admtext['mmshowcache']}</label></td>
				<td><input type='checkbox' name='showcache' value='1'$checked>
				</td></tr>\n";

			### Position the author column to the far right
			$checked = $aright ? ' checked' : '';
			echo "<tr><td><label for='aright'>{$admtext['mmcaright']}</label></td>
				<td><input type='checkbox' name='aright' value='1'$checked/>
				</td></tr>\n";
			echo "</table>
	</div>\n"; #End the Display Options collapsible section

	# Submit button & close the form
	echo "<div style='float:right'>
			<input type='submit' name='b1' value=\"{$admtext['mmsubmit']}\" onclick='return validateSubmit();'></div>
	</form>\n";

	#Separator
	echo "<div class='rrwikidisplay rrhline'></div>\n";
	#Display a message warning that the report could take a long time to generate
	echo "<div class='rrwikidisplay'><b>";
	if ($admtext['mmclongtime1'])
		echo $admtext['mmclongtime1'];
	if ($admtext['mmclongtime2'])
		echo " <span style='color:brown;'>{$admtext['mmclongtime2']}</span>";
	echo "</b></div>\n";

#Put hidden divs here that hold help text that will be displayed in a LITbox popup
#when an info or help button is clicked.  There are five hints. Each has title and body text.
#There is also a footnote that is placed at the bottom of each popup box.
echo "<div style='display:none'>
	<div id='rrspeedhint'>{$admtext['mmspeedhint']}</div>
	<div id='rrspeedtitle'>{$admtext['mmspeedtitle']}</div>
	<div id='rrregexhint'>{$admtext['mmregexhint']}</div>
	<div id='rrregextitle'>{$admtext['mmregextitle']}</div>
	<div id='rrstatushint'>{$admtext['mmstatushint']}</div>
	<div id='rrstatustitle'>{$admtext['mmstatustitle']}</div>
	<div id='rrsectionhint'>{$admtext['mmsectionhint']}</div>
	<div id='rrsectiontitle'>{$admtext['mmsectiontitle']}</div>
	<div id='rrhilitehint'>{$admtext['mmhilitehint']}</div>
	<div id='rrhilitetitle'>{$admtext['mmhilitetitle']}</div>
	<div id='mmfootnote'>{$admtext['mmfootnote']}</div>
</div>\n";

#Close the layout table
echo "</td>
</tr>
</table>\n";
#Display the standard admin page footer and end the page
echo "<div style='text-align:right;' class='normal'>$tng_title, v.$tng_version</div>
</body>
</html>\n";

#######################################################
##### End of main program - PHP Functions follow ######
#######################################################

#######################################################
# Display a radio button for a SortBy option
# $twopartvalue is a vbar-delimited string with
# - The name of the field driving the sort. This value (modname,
#     filename, etc.) supplies the radio button label AND the value.
# - Classnames that wind up controlling whether the option is visible
#   (e.g. when the Wiki or Site 2 are not active)
function showSortChoice($twopartvalue) {
	global $sb, $admtext;
	$sorttype = strstr($twopartvalue, '|', true);
	$class = trim(strstr($twopartvalue, '|'), '|');
	$checked = ($sorttype == $sb) ? ' checked' : '';
	echo "<label class='$class'><input type='radio' name='sb'
		value='$sorttype'$checked>{$admtext["mmsort$sorttype"]}</label>&nbsp;\n";
} #end function showSortChoice

#######################################################
#Generate HTML for the status value columns: installation status,
#comparison between a site and the wiki, and comparison between site1
#and site 2. Values for a given status column (maybe all of them) are hidden
#if relevant form fields (compare to the wiki; include a second site) are
#not specified.
#The values for a given status column are represented as checkboxes displayed #in a left-floated div. Thus there is a column of checkboxes for each of
#status columns that will be displayed in the results table.
#(You cannot search for 'installation status' values.)
#Since the status value checkboxes take up a good bit of space, theyand
#are initially hidden, and a snlink button displays them.
#The return value is the HTML code for all status columns.
function defineStatusSelectionColumns() {
	global $admtext, $options, $statusValues;

	#Define the "Search for Status Values:" heading and the "Show/Hide Status values link
	$html = "<div id='statusdiv'>
		<span class='rrtextlink' onclick=\"return showPopupHint('status',420,235);\" title=\"{$admtext['mmstatustitle']}\"><img src='img/info_2.png'></span>
		<b>{$admtext['mmstatusvalues']}:</b> &nbsp;&nbsp;&nbsp;
		<a href='#' id='statusbutton' class='snlink rrwikiorsite2' style='padding:2px;'
		onclick='return toggleStatusCriteriaVisibility();'>{$admtext['mmshowstatusvalues']}</a>
		<span class='rrwikiNORsite2 mmdisplaynone;'>({$admtext['mmcnotenabled']})</span>
		</div>\n";

	#Define a div to contain the lists of status values for the status fields.
	$html .= "<div id='statuswrap' style='display:none;line-height:1em;'>\n";
	#Call defineAColumnOfStatusCheckboxes for each of the status fields
	#Each field's values are listed in a column. Classnames associated with
	#each field determine whether that field's values are visible.
	$html .= defineAColumnOfStatusCheckboxes('mmsite1vwikistatus', 'site1vwiki', 'rrwikidisplay nottype0', $statusValues['site-wiki']);
	$html .= defineAColumnOfStatusCheckboxes('mmsite2vwikistatus', 'site2vwiki', 'rrwikiandsite2 nottype1', $statusValues['site-wiki']);
	$html .= defineAColumnOfStatusCheckboxes('mmsite2vsite1status', 'site2vsite1','rrsite2display nottype1', $statusValues['site2-site1']);
	$html .= "</div>\n"; #End of status wrap div

	return $html;
} #end function defineStatusSelectionColumns

############################################################################
#Generate the HTML to display one column of checkboxes that select status values.
#The columns are "site1 v wiki", "site2 v wiki", and "site 2 v site1".
#Arguments:
# $colHeading - The $admtext subscript for the column heading.
# $basename - The div ID of the column, and the base fieldname for every field in this column.
# $styleclass - Can be rrwikidisplay &/or rrsite2display to cause this column to be hidden/displayed
#        with the Wiki and/or site2.
# $statusValues - An array that provides the checkbox value for each status value in this column.
#        Some (e.g. '<wiki', '>site1') are exactly as displayed. Others are $admtext subscripts.
function defineAColumnOfStatusCheckboxes($colHeading, $basename, $styleclass, $statusValues) {
	global $admtext;

	#All columns have the class rrstatuscolumn, which causes the column to float left.
	#All columns also have a class that determines when they are hidden.
	$styleclass .= ($styleclass ? ' ' : '') . 'rrstatuscolumn';

	#Define a div that holds the column.
	$html = "<div class='$styleclass'><strong id='$basename'>{$admtext[$colHeading]}</strong>";
	#To allow all of the status checkboxes in a given column to have the same fieldname,
	#add [] to the end #of the fieldname, and add 'field' to make sure that these field names
	#are distinct from other fields in the form.
	$fieldname = "{$basename}field[]";
	foreach ($statusValues AS $value) {
		#See whether this value needs to be converted for display.  If not, then use an entity to display '<'.
		if (isset($admtext[$value])) $htmlvalue = $admtext[$value];
		else $htmlvalue = str_replace('<', '&lt;', $value);
		#Each checkbox goes on a separate line.
		$html .= "<div><label><input type='checkbox' name='$fieldname' class='statuscheckbox'
			value='$value'/>$htmlvalue</label></div>\n";
	}
	return "$html</div>\n";
} #End function defineAColumnOfStatusCheckboxes

###########################################################################
# Function to generate the HTML for a page section (typically a subform) that can be hidden and displayed
# by clicking on an arrow icon or the section title.
# The arrow icon (which changes depending on whether the page section is open or closed) and the section
# title are enclosed within a single <a> element.
# This function is derived from the TNG function displayToggle, but this version allows the sections
# to be hierarchically organized.  The TNG function allows just a series of sections.
# Arguments:
#   $section = the ID suffix of the arrow icon, section div. and appended text.
#   $intialState = PHP expression; true=>show div w/ collapse icon; false=> hide div w/expand icon
#   $runtimeState = A Javascript expression that tells the JavaScript toogleCompareSection function
#        whether the section needs to be opened or closed. (true=open)
#   $headline = The text string label next to the toggle icon, which is part of the action hyperlink.
#   $subhead = A text string that is placed below the icon and headline
#   $append = A text string that is placed on the the same line as the headline, but is not part of
#       the action hyperlink.
# The return value is the HTML code for the section heading.
function generateSectionToggle($section, $initialState, $runtimeState, $headline, $append="") {
	global $admtext;
	$hidden = $initialState ? ' mmdisplaynone' : '';
	$imagefile = $initialState ?  'tng_collapse.gif' : 'tng_expand.gif';
	$rval = "<div class='mmsectionhead'>
		<span class='rrtextlink mmsectiontext'
		onclick=\"toggleFormSection('$section',($runtimeState ? 'off' : 'on'))\">
		<img id='img$section' src='img/$imagefile' title='{$admtext['toggle']}'
			alt='{$admtext['toggle']}' width='15' height='15' border='0'/>
		$headline</span>
		<span style='padding-left:2.5em;' class='$hidden' id='append$section'>$append</span>
		</div>\n";
	return $rval;
} #end function generateSectionToggle

##################################################################
#This function defines the Mod Manager tab menu for all Mod Manager programs.
#Identical copies of this function are placed in each Mod Manager program.
function set_horizontal_tabs( $show_analyzer = NO, $show_developer = NO, $show_updates = NO  ) {
   global $admtext;

   $modtabs = array();
   $modtabs[0] = array(1, "admin_modhandler.php", $admtext['modlist'],"modlist");
   $modtabs[1] = array(1,"admin_showmodslog.php",$admtext['viewlog'],"viewlog");
   $modtabs[2] = array(1,"admin_modoptions.php",$admtext['options'],"options");
   if ( $show_analyzer == YES)
      $modtabs[3] = array(1,"admin_analyzemods.php",$admtext['analyzefiles'],'files');
   if ( $show_developer == YES)
      $modtabs[4] = array(1,"admin_modtables.php",$admtext['parsetable'],'parser');
   if ( $show_updates == YES)
      $modtabs[5] = array(1,"admin_modupdates.php",$admtext['recommendedfixes'],'updates');
	if (file_exists('rrinnermodmenu_newtab.php'))
		include_once('rrinnermodmenu_newtab.php');
	if (!function_exists('rrimmNewTab')) {function rrimmNewTab($modname){}}
	$modtabs['rrmmc1'] = array(1,"rrmodcompare_form.php", $admtext['mmcompare'].rrimmNewTab('Mod Manager Compare'), "compare");
	if (file_exists('rrmodcheckfiles.php'))
		$modtabs['rrmmcf'] = array(1,"rrmodcheckfiles.php",$admtext['rrmmcf-checkfiles'].rrimmNewTab('Mod Manager Check Files'), 'check');
	if (file_exists('rrmodutilities.php'))
		$modtabs['rrmmu1'] = array(1,"rrmodutilities.php", $admtext['rrmu-utilities'].rrimmNewTab('Mod Manager Utilities'), 'utilities');
   return $modtabs;
} #End function set_horizontal_tabs

################ end of PHP functions #######################
?>