<?php
##### rrmodcompare_help.php, installed by ###Mod Manager Compare, by Robin Richmond #####
include("../../helplib.php");
echo help_header("Help: Mod Comparison Report");
?>
<body class="helpbody">
<style>
h2 {margin-top:0;}
ul.p>li,ol.p>li {margin-top:1ex; margin-bottom:1ex;}
</style>
<table id='top' width="100%" border="0" cellpadding="10" cellspacing="2" class="tblback normal">
<tr class="fieldnameback">
	<td class="tngshadow">
		<p style="float:right; text-align:right" class="smaller menu">
			<a href="https://tng.community" target="_blank" class="lightlink">TNG Forum</a> &nbsp; | &nbsp;
			<a href="https://tng.lythgoes.net/wiki" target="_blank" class="lightlink">TNG Wiki</a><br />
			<a href="backuprestore_help.php" class="lightlink">&laquo; Help: Utilities</a> &nbsp; | &nbsp;
			<a href="index_help.php" class="lightlink">Help: Getting Started &raquo;</a>
		</p>
		<span class="largeheader">Help: Mod Comparison Report</span>
		<p class="smaller menu">
			<a href="#overview" class="lightlink">Overview</a> &nbsp; | &nbsp;
			<a href="#report" class="lightlink">The Mod Comparison Report</a> &nbsp; | &nbsp;
			<a href="#mymods" class="lightlink">The 'My Mods' Report</a>
			<a href="#kickoff" class="lightlink">The Kickoff Form</a> &nbsp; | &nbsp;
			<a href="#modoptions" class="lightlink">Mod Manager Options</a> &nbsp; | &nbsp;
			<a href="#caching" class="lightlink">Caching of Wiki Articles</a>
		</p>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<h2 id="overview">Overview</h2>
		<p style='margin-bottom:0;'>The Mod Comparison Report is a component of the TNG Mod Manager.
		The Comparison Report compares a site's mods (most particularly the version number) to
		<ul style='margin-top:0;margin-bottom:1ex;'>
			<li>The mods in a second site, and/or</li>
			<li>The corresponding mod articles in the TNG Wiki.</li>
		</ul>
		<p>The primary purpose of the Comparison Report is to see whether the TNG Wiki has new versions of mods on the user's site. The report can display much more information than that, but one report option does focus on mods that have a newer version on the Wiki.</p>
		<p>To run the comparison report, the user must click on the "Compare" tab in the Mod Manager.
			The Compare tab brings up a "kickoff form" through which the user can specify report options.
			There are three "levels" of options that control the contents of the report, plus a fourth section that specifies options that controls the display (formatting and highlighting) of the report.</p>
		<p>Default values for most of the options on the kickoff form are specified in the Mod Manager Options screen.
			The Mod Manager Options screen also provides an option that determines which level of options are open the first time that the user invokes the kickoff form in a web browser session.</p>
		</ul>
	</td></tr>

<tr id='report' class="databack">
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Top</a></div>
		<h2>The Report</h2>
		The report starts by displaying the search specifications (which are provided by the Kickoff form).
		<p>
		As the report program starts to read the cfg files on the local site, it display the site address, and then, when it has finished reading them, it reports the number of .cfg file it looked at, and the number of mods it accepted.  If a second TNG site has been selected, the program repeats that process with the second site.</p>
		<p>
		If the report program has been told to compare the mods to the Wiki (which is almost always the case), it says "Reading Wiki Articles..." and proceeds to list the name of each Wiki article as it is read either from the Wiki Server or the cache. Reading Wiki articles from the Wiki server can take more than 2 seconds each, so if the program is not using the local cache, it can take several minutes to read all of the Wiki articles.</p>
		<p>
		When the report program finishes reading the Wiki articles, it erases the list of article names, and displays the results table. </p>

		<h4>The Results Table</h4>
		The results table has four sets of columns, each separated by a heavy border.
		<ol class='p'>
		<li><b>General information about the mod</b>
			<ul>
				<li>Mod name. If there are multiple versions of one mod, only the latest version is included in the report.</li>
				<li>The .cfg filename.</li>
				<li>The primary mod author.  The author is determined as follows:
					<ol type='a'>
					<li>First, the program looks for %author% tags in the .cfg file, and reports the author listed in the first %author% tag.
					<li>If the .cfg file does not contain any %author% tags, the program looks at the Mod Author field in the sidebar of the mod's Wiki article. The program goes to some trouble to parse the contents of that field for the <i>first</i> author in case the field lists multiple authors.
					</ol>
					The author name is a hyperlink if it is hyperlinked in its source file, and the full list of authors is saved as pop-up text in the author column.</li>
			</ul>
		</li>
		<li><b>Information about the Local mod; the .cfg file on the user's server, which is labeled as "Site 1"</b>
			<ul>
				<li>Mod installation status (just like the Mod Manager's Mod List, except that color highlighting is optional).</li>
				<li>Version number.</li>
				<li>The "Site1 v Wiki" status - a comparison of the version recorded in the .cfg file and the mod version recorded in the Wiki article.
			</ul></li>
		<li><b>Information about the Remote mod; the .cfg file on a second server, which is labeled ast "Site 2"</b>
			<ul><li>(Three columns corresponding the the three columns for Site 1).</li>
				<li value='4'>The "Site2 v Site1" status, which is a comparison of the mod versions on site 1 and site 2.</li>
			</ul>
		<li><b>Information about the mod recorded in the Wiki article</b>
			<ul>
				<li>Wiki status, which indicates whether a mod number was found in the, more than one Mod number was found, whether no valid mod number could be found, or whether the Wiki article is missing from the Wiki server.</li>
				<li>Wiki version - the version number that is recorded in the "Download link" field in the Wiki article's sidebar. If more than one version number is found in that field, then
					<ol type='a'>
					<li>The highest version number is displayed, and</li>
					<li>All of the version numbers in the the "Download link" field are strung together and can be viewed as a pop-up. A plus sign is placed at the end of the primary version number to indicate that there is more information in a pop-up.</li>
					</ol></li>
				</li>
				<li>Mod Update Date. This is not the update date of the mod article (which is basically meaningless), but rather is the Mod Update date, which is determined from
					<ol type='a'>
					<li>The "Mod Updated" field in the Wiki article sidebar, or</li>
					<li>The highest date (irrespective of version number) found in the Revision History section of the Wiki article.</li>
					</ol></li>
				<li>Wiki Article name, which is a hyperlink to the Wiki article.</li>
					of the Mod installation status (just like the Mod Manager's Mod List, except that color highlighting is optional).</li>
				<li>When cached, represented as a date/time <i>difference</i> from "now" rather than as an absolute date/time.  As discussed below, the Comparison Report does not necessarily read the Wiki article every time the report is run.(Reading all of the Wiki article is just too slow.) The Comparison Report keeps a cached copy on the user's web server, and can use the cached copy.</li>
			</ul></li>
		</ol>

		<h4>Other Report Details</h4>
		<ol class='p'>
			<li>As noted above, if there are multiple copies of a mod on a TNG server, the report will only consider the .cfg file with the highest version number.  If, for instance,
				<ol><li>Site 1 has the .cfg files for mod version 10.1.0.3 and for version 11.0.1.1, and</li>
					<li>Site 2 has just version 10.1.0.3</li>
				</ol>
				The Comparison Report will not compare the two copies of version 10.1.0.3, but instead, will compare Site 1's version 11.0.1.1 to Site 2's version 10.1.0.3.</li>
			<li>The options that control the appearance of the Comparison Report are described in the "Kickoff Form" section below, but it is worthwhile to mention some aspects of those options here:
				<ul>
					<li>The highlighting of values within the status columns can be suppressed, but if it is enabled, then
						<ol type='a'>
						<li>The installation status values are shaded exactly like the installation status values in the Mod Manager Mod List.</li>
						<li>The status values in the "Site1 v Wiki" and "Site2 v Wiki" columns are shaded with the same colors as the installation status column, but, of course, the values are different.  The color do, however, have essentially the same relative meanings; viz:
							<ul><li>Green (installed) is good,</li>
								<li>Pink (unable to install) is "bad",</li>
								<li>Orange (partially installed) is between good and bad, and</li>
								<li>Whiteish (OK to install) is "normal".</li>
							</ul></li>
						<li>The Wiki status values are shaded in a similar way.</li>
						</ol></li>
					<li>Depending on another display option that is labeled as "probably most useful for mod programmers", superscripts can be attached to
						<ol type='a'>
						<li>The Author name, to indicate whether the author was defined in
							<ol><li>The Site 1 .cfg file,</li>
								<li>The Site 2 .cfg file, or</li>
							</ol><ol type='A'>
								<li value='23'>The Wiki article</li>
							</ol>and</li>
						<li>The Wiki Article name, to indicate with <sup>UC</sup> whether there is an Under Construction message in the Wiki article.</li>
						</ol></li>
				</ul></li>
			<li>When the Comparison Report is sorted by a column other than the mod name or the filename,
				horizontal bars are placed in the results table between values of the sort key. (It isn't useful to separate values of the mod name or the filename, since each mod name or filename value can be associated with only one mod.)</li>
			<li>Assume for the moment that
				<ul><li>A second TNG site is included in the report,</li>
					<li>Copies of a mod exist on both sites, and</li>
					<li>The two copies are sufficiently different that the mod on one site is accepted by the search criteria and the mod on the other site is not.</li>
				</ul>
				In such a case, only one of the two copies of the mod is included in the report. The blank space left in the report columns for the other site will likely imply that the mod does not exist on that other site. But the truth is that the mod just didn't match the search criteria. There is no easy way for the report program to know the difference between rejecting a mod and a missing mod, but perhaps that problem can be rectified in a future version.</li>
		</ol>
	</td></tr>

<tr id='mymods' class="databack">
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Top</a></div>
		<h2>The 'My Mods' Report</h2>
		Ron Krzmarzick created a version of the Mod Comparison Report that is specifically intended to be run remotely.
		That is, when it is installed on your site (as part of the Mod Manager Compare mod), you can link to it from,
		for example, a "See My Mods" link in a TNG Wiki page.
		<div class='p'>
		<p>The program is named <a href='..\..\rrmodcompare_mymods.php' target='_blank'>rrmodcompare_mymods.php</a>.
		It</p>
		<ol>
		<li>Accepts some query-string parameters, but doesn't depend on a kickoff form.</li>
		<li>Compares non-private mods on your site with the Wiki versions,</li>
		<li>Omits several columns that are in the full Mod Manager Comparison Report, and</li>
		<li>Uses cache method 3, which does not update the cache.</li>
		</ol>
	</td></tr>

<tr id='kickoff' class="databack">
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Top</a></div>
		<h2>The Kickoff Form</h2>
		<p>The "Kickoff Form" is the form that you use to select report options and launch a Mod Comparison Report.
		The kickoff form is explained in some detail in
			<a href='https://tng.lythgoes.net/wiki/index.php/Mod_Manager_Compare#Visualizations'
			target='_blank'>the Mod Comparison Report TNG Wiki article</a>
	</td></tr>

<tr id='modoptions' class="databack">
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Top</a></div>
		<h2 id="modoptions">The Mod Manager Options</h2>
		<p>For the most part, the "Mod Comparison Report" options section of the Mod Manager Options provides default values
			for the Mod Comparison Report kickoff Form.
			As with other TNG programs, the default options take effect only the first time you run a Mod Comparison Report.
			After that (until you close all copies of the web browser),
			the kickoff form's default values will be based on the options you chose for your most recent report.
		</p>
		<p>See the Mod Manager Options section of
			<a href='https://tng.lythgoes.net/wiki/index.php/Mod_Manager_Compare#Mod_Manager_Options'
			target='_blank'>the Mod Comparison Report TNG Wiki article</a>.
	</td>
</tr>

<tr class="databack">
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Top</a></div>
		<h2 id="caching">Caching of TNG Wiki Content</h2>
		The Mod Comparison Report saves a cache of Wiki article data on your TNG server so that, when the report is run again, it doesn't have to undergo the slow process of reading each Wiki Article, and so that it does not drag down the TNG Wiki server performance. Unfortunately, there is no way to determine whether the relevant data in the Wiki article has been updated without reading the Wiki article, which would spoil the point of caching.
		<p>Consequently, the kickoff form specifies a cache age limit. If the cached data - for a specific Wiki article - is older than that age, the Wiki article will be re-read and its cache will be refreshed.</p>
		<p style='margin-bottom:0;'>
		If you know (or think) that certain Wiki articles have been updated, you can refresh the cache for those specific articles if you:
		<ol style='margin-top:0;margin-bottom:1ex;'>
			<li>Search for those specific mods by name (or name substring), and</li>
			<li>Specify a small expiration time (say, 20 minutes, 10 days, 6 weeks - whatever is appropriate).
		</ol>
		<p>Once you have run a report showing those specific mods, you can, if you wish, then run another report without the name specification, <em>and using only the cache</em>, so that you see those mods and others in one report that runs quickly, because it does not have to read Wiki articles.</p>
	</td></tr>

</table>
</body>
</html>